%Classification of leaf data setby Fahad (18261)
%EE566 Pattern Recognition (FENS Sabanci University)Semester project
clear all;
clear all;
clc

filename_train = 'LeafDataset-train-50.xlsx';
filename_test = 'LeafDataset-test-50.xlsx';
TrainData = xlsread(filename_train);
TestData = xlsread(filename_test);

Trlabels=TrainData(:,1);
TrFeatures=TrainData(:,2:2004);

mins = min(TrFeatures);
TrFeatures = bsxfun(@minus,TrFeatures,mins);
maxes = max(TrFeatures);
TrFeatures = bsxfun(@rdivide,TrFeatures,maxes);

Tstlabels=TestData(:,1);
TstFeatures=TestData(:,2:2004);

TstFeatures = bsxfun(@minus,TstFeatures,mins);
TstFeatures = bsxfun(@rdivide,TstFeatures,maxes);


nclass = length(unique(Trlabels));

Y = zeros(length(Trlabels),nclass);
Y(sub2ind(size(Y),(1:length(Trlabels))',Trlabels)) = 1;

Yt = zeros(length(Tstlabels),nclass);
Yt(sub2ind(size(Yt),(1:length(Tstlabels))',Tstlabels)) = 1;

mynn = Nn(size(TrFeatures,2),nclass);
mynn.addlayer(80,'sigmoid');
mynn.addlayer(200,'sigmoid');
mynn.addlayer(nclass,'softmax');    

mynn.initmethod = 'rbm';
mynn.losstype = 'ls'; 
mynn.batchsize = 0;

mynn.set('lambda',0.0001);
mynn.set('regtype',2);

mynn.initialize();
mynn.pretrain(TrFeatures);
mynn.numepochs = 50;
mynn.numepochsTop = 0;
bpout = mynn.backprop(TrFeatures,Y,TstFeatures,Yt);




