%Classification of leaf data setby Fahad (18261)
%EE566 Pattern Recognition (FENS Sabanci University)Semester project

clc
close all
clear all

%Number of instances for each class
filename_train = 'LeafDataset-train-50.xlsx';
filename_test = 'LeafDataset-test-50.xlsx';

TrainData = xlsread(filename_train);
TestData = xlsread(filename_test);

Xtrain = TrainData(:,2:2004);
Ytrain=TrainData(:,1); 

Xtest = TestData(:,2:2004);
Ytest=TestData(:,1); 

ENS=fitensemble(Xtrain,Ytrain,'Bag',200,'Tree','type','classification')
loss=loss(ENS,Xtest,Ytest,'mode','cumulative');
figure;
plot(loss);
xlabel('Number of trees');
ylabel('Test classification error');

minimum=min(loss)
mintree=find(loss==minimum)