%Classification of leaf data setby Fahad (18261)
%EE566 Pattern Recognition (FENS Sabanci University)Semester project
%Using K-Nearest Neighbors classifier

clc
close all
clear all

filename_train = 'LeafDataset-train-50.xlsx';
filename_test = 'LeafDataset-test-50.xlsx';

TrData = xlsread(filename_train);
TstData = xlsread(filename_test);

% Making Data set. First column is Label.All others features
TrainData = dataset(TrData(:,2:2004),TrData(:,1)); 
TestData = dataset(TstData(:,2:2004),TstData(:,1)); 

% Using KNN for k=[1,2,3...25]
   for k=1:25
       
    classifier = knnc(TrainData, k);
    Error(k)= testc(TestData*classifier)
    
   end
plot(Error,'-','LineWidth',2)
xlabel('K Value')
ylabel('Error')
title('Plot of error for differnt K values in KNN')

% Finding K with minimum error.
minimum=min(Error)
k_min=find(Error==minimum)
  
